import { EventEmitter, OnInit, ElementRef, ChangeDetectorRef } from '@angular/core';
import { HacDatepickerOptions } from './hac.datepicker.options';
import { HacCalendarModel, HacCalendarDayModel, WeekDay } from '../models/hac.calendar.model';
export declare class HacDatepicker implements OnInit {
    private elementRef;
    private changeDetector;
    private _startDate;
    startDate: Date | string;
    private _endDate;
    endDate: Date | string;
    startDateChange: EventEmitter<string | Date>;
    endDateChange: EventEmitter<string | Date>;
    selected: Date | string;
    readonly selectedChange: EventEmitter<Date | string>;
    private _options;
    options: HacDatepickerOptions;
    calendars: HacCalendarModel[];
    weekDayList: WeekDay[];
    private _collapsed;
    collapsed: boolean;
    private forcedSelectionKind?;
    private hoverDate?;
    constructor(elementRef: ElementRef, changeDetector: ChangeDetectorRef);
    ngOnInit(): void;
    onClick(event: any): void;
    buildCalendarModel(): void;
    select(day: HacCalendarDayModel): void;
    isSelected(day: HacCalendarDayModel): boolean;
    isDisabled(day: HacCalendarDayModel): boolean;
    isStart(day: HacCalendarDayModel): boolean;
    isEnd(day: HacCalendarDayModel): boolean;
    inRange(day: HacCalendarDayModel, useHover?: boolean): boolean;
    setHoverDate(day: HacCalendarDayModel): void;
    clearDates(): void;
    prevMonth($event?: Event): void;
    nextMonth($event?: Event): void;
    toggleCalendar(): void;
    getSelectionKind(): SelectionKind;
    forceSelectionKind(kind?: SelectionKind): void;
    selectToday(): void;
    isTodayActionEnabled(): boolean;
    getSelectorElem(): HTMLElement;
    getCalendarWidthMode(): string;
    isPrevArrowVisible(calendarIndex: number): boolean;
    isNextArrowVisible(calendarIndex: number): boolean;
    private setOptionsDefaults();
    private setStartDate(day?);
    private setEndDate(day?);
    private getFirstRangeDay();
    private getLastRangeDay();
    private isInDayList(day);
    private animate();
}
export declare type SelectionKind = 'start' | 'end';
